#ifndef TRANSFORMMATRIX_H
#define TRANSFORMMATRIX_H

#include "IDataType.h"
#include "Matrix.h"
#include <vector>
using namespace std;

class TransformMatrix : public IDataType
{
private:
    vector<Matrix<double>*> m_transformMats;
public:
    TransformMatrix() : IDataType()
    {addType(TRANSFORMMATRIX_T);}

    ~TransformMatrix()
    {clear();}

    void addTransformMatrix(Matrix<double>* mat) {m_transformMats.push_back(mat);}
    Matrix<double>* getTransformMatrix(int i) const {return m_transformMats[i];}

    void clear()
    {
        for(unsigned int i=0; i<m_transformMats.size(); ++i)
            delete m_transformMats[i];
        m_transformMats.clear();
    }
    unsigned int getSize() const {return m_transformMats.size();}
    bool isValid() const {return m_transformMats.size() > 0;}
};

#endif
