#ifndef LANDMARKSTOPITEM_H
#define LANDMARKSTOPITEM_H

#include "FormItem.h"
#include "ew/view3_landmarks.h"
#include "ew/form3.h"
#include "../IdDialog.h"

class SemiLandmarksTopItem;

class LandmarksTopItem : public ViewTreeItem
{
Q_OBJECT

private:
    bool m_templateTreeView;
    QAction* m_mapAllAction;
    ViewTreeItem* m_assignhere;
    //QAction* addAction;
    //QAction* m_splineAction;
    QAction* m_projectAction;
    QAction* m_fixAction;

    LandmarksTopItem() : ViewTreeItem(LANDMARKS_ITEM), m_templateTreeView(false), m_mapAllAction(0), m_assignhere(0)/*, addAction(0)//, m_splineAction(0)*/, m_projectAction(0), m_fixAction(0)
    {fillContextMenu();}

public:
    LandmarksTopItem(FormItem* parent) :  ViewTreeItem(parent, LANDMARKS_ITEM), m_templateTreeView(false), m_mapAllAction(0), m_assignhere(0)/*, addAction(0)//, m_splineAction(0)*/, m_projectAction(0), m_fixAction(0)
    {fillContextMenu(); }

    void fillContextMenu()
    {
        QAction* focusAction = new QAction("Focus View", m_contextMenu);
        m_contextMenu->addAction(focusAction);
        connect(focusAction, SIGNAL(triggered()), this, SLOT(focusView()));
        m_contextMenu->addSeparator();

        QAction* colorAction = new QAction("Color", m_contextMenu);
        m_contextMenu->addAction(colorAction);
        connect(colorAction, SIGNAL(triggered()), this, SLOT(signalColorChange()));

//        QAction* labelsAction = new QAction("Labels", m_contextMenu);
//        labelsAction->setCheckable(true);
//        m_contextMenu->addAction(labelsAction);
//        QAction* projectToSur = new QAction("Project Semi-Landmarks", m_contextMenu);
//        m_contextMenu->addAction(projectToSur);
//        QAction* orientAction = new QAction("Orient and Relax Semi-Landmarks", m_contextMenu);
//        m_contextMenu->addAction(orientAction);
//        QAction* optimizeAction = new QAction("Optimize", m_contextMenu);
//        m_contextMenu->addAction(optimizeAction);

        QMenu* symbolMenu = new QMenu("Symbol");
        QAction* crossAction = new QAction("Cross", symbolMenu);
        crossAction->setCheckable(true);
        crossAction->setChecked(true);
        connect(crossAction, SIGNAL(triggered()), this, SLOT(signalXSymbol()));
        symbolMenu->addAction(crossAction);

        QAction* circleAction = new QAction("Circle", symbolMenu);
        circleAction->setCheckable(true);
        connect(circleAction, SIGNAL(triggered()), this, SLOT(signalCircleSymbol()));
        symbolMenu->addAction(circleAction);

        QAction* dotAction = new QAction("Dot", symbolMenu);
        dotAction->setCheckable(true);
        symbolMenu->addAction(dotAction);
        connect(dotAction, SIGNAL(triggered()), this, SLOT(signalDotSymbol()));
        m_contextMenu->addMenu(symbolMenu);

        QActionGroup* symbolsGroup = new QActionGroup(m_contextMenu);
        symbolsGroup->addAction(crossAction);
        symbolsGroup->addAction(circleAction);
        symbolsGroup->addAction(dotAction);
    }

    void enableMapChild( int index, bool enable );

    void enableRegChild( int index, bool enable );

    void templateTreeView( bool temp )
    {
        m_templateTreeView = temp;

        if( m_templateTreeView )
        {
//            m_contextMenu->addSeparator();
//            m_splineAction = new QAction("Compute Spline", m_contextMenu);
//            m_contextMenu->addAction(m_splineAction);
//            connect(m_splineAction, SIGNAL(triggered()), this, SLOT(splineLmk()));

//            QAction* combo3Action = new QAction("Match", m_contextMenu);
//            m_contextMenu->addAction(combo3Action);
//            connect(combo3Action, SIGNAL(triggered()), this, SLOT(matchLmk()));
            m_contextMenu->addSeparator();
            QAction* combo2Action = new QAction("Calculate Spline", m_contextMenu);
            m_contextMenu->addAction(combo2Action);
            connect(combo2Action, SIGNAL(triggered()), this, SLOT(matchSplineLmk()));
            QAction* comboAction = new QAction("Calculate Spline + Warp unmatched", m_contextMenu);
            m_contextMenu->addAction(comboAction);
            connect(comboAction, SIGNAL(triggered()), this, SLOT(matchSplineWarpLmk()));
        }

        if( m_templateTreeView && !m_mapAllAction )
        {
            m_contextMenu->addSeparator();
            m_mapAllAction = new QAction("Warp all unmatched landmarks", m_contextMenu);
            m_contextMenu->addAction(m_mapAllAction);
            connect(m_mapAllAction, SIGNAL(triggered()), this, SLOT(mapAllLmk()));
            mapAllEnable( false );
        }
        else if( !m_templateTreeView )
        {
//            if( !addAction )
//            {
//                m_contextMenu->addSeparator();
//                addAction = new QAction("Add Landmarks here", m_contextMenu);
//                addAction->setCheckable( true );
//                addAction->setChecked( true );
//                m_contextMenu->addAction(addAction);
//                connect(addAction, SIGNAL(triggered()), this, SLOT(addHere()));
//            }
            m_contextMenu->addSeparator();
            QAction* surfaceAction = new QAction("Add Surface Semi-Landmark", m_contextMenu);
            m_contextMenu->addAction(surfaceAction);
            connect(surfaceAction, SIGNAL(triggered()), this, SLOT(addSurfaceSemiLandmark()));
//            QAction* curveAction = new QAction("Add Curve Semi-Landmark", m_contextMenu);
//            m_contextMenu->addAction(curveAction);
//            connect(curveAction, SIGNAL(triggered()), this, SLOT(addCurveSemiLandmark()));
            m_contextMenu->addSeparator();
            m_projectAction = new QAction("Project", m_contextMenu);
            m_contextMenu->addAction(m_projectAction);
            connect(m_projectAction, SIGNAL(triggered()), this, SLOT(project()));
            m_fixAction = new QAction("Fix all Landmarks", m_contextMenu);
            m_contextMenu->addAction(m_fixAction);
            connect(m_fixAction, SIGNAL(triggered()), this, SLOT(fix()));
        }
    }

    void select( const QString& parentid, const QString& childid = "" );

    bool doesChildExist( const QString& parentid, const QString& childid );

    void mapAllEnable( bool enable )
    {
        if( m_mapAllAction )
        {
            m_mapAllAction->setEnabled( enable );
        }
    }

    void projectEnable( bool enable )
    {
        if( m_projectAction )
        {
            m_projectAction->setEnabled( enable );
        }
    }

    QString getSelectedLandmarkID();

public slots:
//    void addHere() {assignLandmarksHere(0);}
    void focusView() {emit lmkFocus(m_parentForm, this);}
    void addSurfaceSemiLandmark(const QString& suggestedName = "")
    {
        addSemiLandmarkSet( 0, suggestedName );

    }
//    void addCurveSemiLandmark()
//    {
//        addSemiLandmarkSet( 1 );
//    }
    void addLandmarkItem(const QString& lmkId);
    void signalDelete(int index);
    void signalDelete(FormItem* semipatch, ViewTreeItem* semilmk, int index);
    void signalMap(int index);
    void signalMapAll(int index);
    void signalReg(int index);
    void signalXSymbol() {emit lmkSymbolChanged(m_parentForm, EW_View3_Landmarks::SYMBOL_CROSS);}
    void signalCircleSymbol() {emit lmkSymbolChanged(m_parentForm, EW_View3_Landmarks::SYMBOL_CIRCLE);}
    void signalDotSymbol() {emit lmkSymbolChanged(m_parentForm, EW_View3_Landmarks::SYMBOL_DOT);}
    void signalColorChange() {emit lmkColorChanged(m_parentForm);}
    void mapAllLmk() {emit lmkMappedAll(m_parentForm, -1);}
    void assignLandmarksHere( ViewTreeItem* vti );
    void matchSplineWarpLmk() { emit matchSplineWarp(); }
    void matchSplineLmk() { emit matchSpline(); }
    //void matchLmk() { emit match(); }
    //void splineLmk() { emit spline(); }
    void project() {emit lmkProject(m_parentForm, this, 0);}
    void fix() { emit lmkState( m_parentForm, this, -1, EW_Form3::STATE_SET ); }
    void rename(FormItem* form, ViewTreeItem* item, int index, const QString& newID)
    {
        emit lmkRename( form, item, index, newID );
    }
    void state( FormItem* form, ViewTreeItem* item, int index, int state )
    {
        emit lmkState( form, item, index, state );
    }

private slots:
    void project(FormItem* form, ViewTreeItem* item, int index) { emit lmkProject( form, item, index ); }
    void slide(FormItem* form, ViewTreeItem* item, int index, bool slide) { emit lmkSlide( form, item, index, slide); }

signals:
    void lmkFocus(FormItem*, ViewTreeItem*);
    void lmkDeleted(FormItem*, int);
    void lmkDeletedChild(FormItem* semipatch, ViewTreeItem* semilmk, int index);
    void lmkMapped(FormItem*, int);
    void lmkMappedAll(FormItem*, int);
    void lmkRegister(FormItem*, int);
    void lmkAdded(FormItem*);
    void lmkSymbolChanged(FormItem*, EW_View3_Landmarks::SymbolType);
    void lmkColorChanged(FormItem*);
    void addLandmarkHere( const QString& id, int semitype );
    void matchSplineWarp();
    void matchSpline();
    //void match();
    //void spline();
    void lmkProject(FormItem*, ViewTreeItem*, int);
    void lmkSlide( FormItem*, ViewTreeItem*, int, bool );
    void lmkRename(FormItem*, ViewTreeItem*, int, const QString&);
    void lmkState( FormItem*, ViewTreeItem*, int, int );

private:
    void addSemiLandmarkSet( int t, const QString& suggestedName = "" );
};
#endif
