// wdkg 2008-2010

#ifndef EW_DATAFLOW_IMAGE3_H_INCLUDED
#define EW_DATAFLOW_IMAGE3_H_INCLUDED 1

#include "ew/dataflow_node.h"
#include "ew/dataflow_array3.h"
#include "ew/dataflow_data3.h"

class EW_Dataflow_Network;

class EW_Dataflow_Image3 : public EW_Dataflow_Node {
public:
  explicit EW_Dataflow_Image3(EW_Dataflow_Network *nw);
  virtual void reset();
  void set_array_node(const EW_Dataflow_Array3 *arr);
  inline const EW_Dataflow_Array3 *get_array_node() const;
  inline EW_Dataflow_Network::cycle_t get_change_cycle_array_node() const;
  void set_data_node(const EW_Dataflow_Data3 *dat);
  inline const EW_Dataflow_Data3 *get_data_node() const;
  inline EW_Dataflow_Network::cycle_t get_change_cycle_data_node() const;
private:
  virtual void update_helper() const;
  const bool DbgOn;
};

// The rest of this file is private.

inline const EW_Dataflow_Array3 *
EW_Dataflow_Image3::get_array_node() const
{
  return static_cast<const EW_Dataflow_Array3 *>(
   EW_Dataflow_Node::InpDependencies[0]);
}

inline const EW_Dataflow_Data3 *
EW_Dataflow_Image3::get_data_node() const
{
  return static_cast<const EW_Dataflow_Data3 *>(
   EW_Dataflow_Node::InpDependencies[1]);
}

inline EW_Dataflow_Network::cycle_t
EW_Dataflow_Image3::get_change_cycle_array_node() const
{
  return EW_Dataflow_Node::change_cycle_dependencies[0];
}

inline EW_Dataflow_Network::cycle_t
EW_Dataflow_Image3::get_change_cycle_data_node() const
{
  return EW_Dataflow_Node::change_cycle_dependencies[1];
}

#endif
