// wdkg 2008-2010

#ifndef EW_DATAFLOW_NOTIFIER_DH_INCLUDED
#define EW_DATAFLOW_NOTIFIER_DH_INCLUDED 1

class EW_Dataflow_Network;
class EW_Dataflow_Notifier_State;

// This header has the declaration but not the inline implementation.
// It is separated to avoid a header cycle.

class EW_Dataflow_Notifier {
public:
  inline explicit EW_Dataflow_Notifier(EW_Dataflow_Network &network);
  inline virtual ~EW_Dataflow_Notifier();
  inline bool notifier_is_registered() const;
  inline void notifier_register();
  inline void notifier_unregister();
private:
  friend class EW_Dataflow_Notifier_State;
// EW_Dataflow_Notifier_State
  virtual void notifier_handle_cb() = 0;
  EW_Dataflow_Notifier_State &State;
  EW_Dataflow_Notifier *Next;
  bool IsRegistered;
// really private
// undefined
  EW_Dataflow_Notifier(const EW_Dataflow_Notifier &rhs);
  EW_Dataflow_Notifier &operator=(const EW_Dataflow_Notifier &rhs);
};

#endif
