// wdkg 2010

// This class is private to the library.
// Only EW_Dataflow_Network and EW_Dig3 can access it.

#ifndef EW_DIG3_STATE_H_INCLUDED
#define EW_DIG3_STATE_H_INCLUDED 1

// This is to allow network-wide EW_Dig3 state to be kept in
// EW_Dataflow_Network without EW_Dig3 having access to all of
// EW_Dataflow_Network.
// It is like static data for EW_Dig3, except stored in EW_Dataflow_Network.

class EW_Dig3_State {
private:
  friend class EW_Dataflow_Network;
  friend class EW_Dig3;
// EW_Dataflow_Network
  inline EW_Dig3_State();
// EW_Dig3
  inline int next_instance_num();
// really private
  int LastInstanceN;
// undefined
  EW_Dig3_State(const EW_Dig3_State &rhs);
  EW_Dig3_State &operator=(const EW_Dig3_State &rhs);
};

// The rest of this file private.

inline
EW_Dig3_State::EW_Dig3_State() :
 LastInstanceN(0)
{
}

inline int
EW_Dig3_State::next_instance_num()
{
  LastInstanceN++;
  return LastInstanceN;
}

#endif
