// wdkg 2008-2010

#ifndef EW_FORM3_IOERROR_H_INCLUDED
#define EW_FORM3_IOERROR_H_INCLUDED 1

#include <stdexcept>
#include <string>

/// I/O exception

/// EW_Form3_IOError is an exception thrown by methods of EW_Form3 to report
/// input or output errors or bad file formats.
///
/// EW_Form3_IOError is a trivial extension of std::runtime_error.
///
/// EW_Form3_IOError is declared in @c ew/form3_ioerror.h.

class EW_Form3_IOError : public std::runtime_error {
public:
  explicit EW_Form3_IOError(const std::string &s);
};

#endif
