// wdkg 2008-2010

#ifndef EW_SURFACE3_IOERROR_H_INCLUDED
#define EW_SURFACE3_IOERROR_H_INCLUDED 1

#include <stdexcept>

/// I/O Exception

/// EW_Surface3_IOError is an exception thrown by methods of EW_Surface3 to
/// report input or output errors or bad file formats.
///
/// EW_Surface3_IOError is a trivial extension of std::runtime_error.
///
/// EW_Surface3_IOError is declared in @c ew/surface3_ioerror.h.

class EW_Surface3_IOError : public std::runtime_error {
public:
  explicit EW_Surface3_IOError(const std::string &s);
};

#endif
